SystemOrganization addCategory: #'Pier-Setup'!

Object subclass: #PRDistribution
	instanceVariableNames: 'kernel sitemap views commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

!PRDistribution methodsFor: 'pages' stamp: 'tg 5/28/2008 12:42'!
blogPage

	^PBBlog named: 'blog'! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 8/27/2008 01:58'!
commandsPage
	^ commands := (PRPage named: 'commands')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRCommandsWidget;
				yourself);
		contents: '!!!!!!!!Commands
			+widget+'! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 8/26/2008 17:58'!
create

	"self new create"

	| environment stylesheet blog usermanagement |

	environment := self environmentPages.
	kernel root addChild: environment.
	kernel root localEnvironment: environment.

	stylesheet := self stylesheetFile.
	environment addChild: stylesheet.
	kernel root localStyleSheet: stylesheet.

	usermanagement := self userManagementPages.
	kernel root addChild: usermanagement.
	
	blog := self blogPage.
	kernel root addChild: blog.

	kernel root securityDecoration owner: kernel users anyOne.
	kernel root securityDecoration group: kernel groups anyOne.

	environment securityDecoration owner: kernel users anyOne.
	environment securityDecoration otherPermissions: Set new.
	environment securityDecoration group: kernel groups anyOne.

	usermanagement securityDecoration owner: kernel users anyOne.
	usermanagement securityDecoration otherPermissions: Set new.
	usermanagement securityDecoration group: kernel groups anyOne.

	sitemap securityDecoration owner: kernel users anyOne.
	sitemap securityDecoration otherPermissions: Set new.
	sitemap securityDecoration group: kernel groups anyOne.

	views securityDecoration owner: kernel users anyOne.
	views securityDecoration otherPermissions: Set new.
	views securityDecoration group: kernel groups anyOne.

	commands securityDecoration owner: kernel users anyOne.
	commands securityDecoration otherPermissions: Set new.
	commands securityDecoration group: kernel groups anyOne.

	PRPierFrame registerAsApplication: 'pier' kernel: kernel.
! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 8/26/2008 16:44'!
createWithExamples

	self create.
	! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 8/27/2008 01:58'!
environmentPages
	^ (PRPage named: 'environment')
		title: '_Environment';
		addChild: ((PRPage named: 'title')
				contents: '!!*/*';
				yourself);
		addChild: ((PRComponent named: 'search')
				componentClass: PRAjaxSearchWidget;
				yourself);
		addChild: ((PRComponent named: 'menu')
				componentClass: PRChildrenWidget;
				write: 1
					using: PRChildrenWidget descriptionLevel;
				write: true
					using: PRChildrenWidget descriptionHighlightPath;
				yourself);
		addChild: ((PRComponent named: 'navigation')
				componentClass: PRChildrenWidget;
				write: 2
					using: PRChildrenWidget descriptionLevel;
				write: true
					using: PRChildrenWidget descriptionExpand;
				yourself);
		addChild: self sitemapPage;
		addChild: self viewsPage;
		addChild: self commandsPage;
		addChild: self usefulCommandsWidget;
		addChild: ((PRComponent named: 'contents')
				componentClass: PRContentsWidget;
				write: '%c'
					using: PRContentsWidget descriptionHeading;
				yourself);
		contents: '<div class="container">
	<div class="header column span-24">
		<div class="title column span-18">+title+</div>
		<div class="search column span-6 last">+search+</div>
		<div class="menu column span-24 last">+menu+</div>
	</div>
	<div class="body column span-24">
		<div class="navigation column span-6">+navigation+</div>
		<div class="contents column span-18 last">+contents+</div>
	</div>
	<div class="footer column span-24">
		<div class="sitemap column span-6">+sitemap+</div>
		<div class="commands column span-6">+commands+</div>
		<div class="views column span-6">+views+</div>
		<div class="column span-6 last">
			Powered by *Pier>http://www.lukas-renggli.ch/smalltalk/pier*.
			+usefulcommands+
		</div>
	</div>
</div>';
		yourself! !

!PRDistribution methodsFor: 'initialize' stamp: 'tg 5/28/2008 12:03'!
initialize

	kernel := PRKernel named: 'Pier'.! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 8/27/2008 01:58'!
sitemapPage
	^ sitemap := (PRPage named: 'sitemap')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRTreeWidget;
				yourself);
		contents: '!!!!!!!!Sitemap
			+widget+'! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 8/26/2008 14:47'!
stylesheetFile

	^(PRFile named: 'css')
		mimetype: 'text/css';
		contents: 
'
/* pier */
.broken { color: #8a1f11; }
.protected { color: #514721; }

input, textarea {width: 99%;}

a {text-decoration: none;}

/* header */
.header .title a.page {
	outline: none;
	display: block;
}
.header .search input {
	width: 100%;
	outline: none;
}
.header .search ul {
	margin: 0;
	padding: 0;
	background: #fff;
	list-style-type: none;
	border: 1px solid #666;
	border-top: none;
}
.header .search li.selected {
	background-color: #009;
}
.header .search li {
	margin: 0;
	display: block;
	padding: 0.2em;
	cursor: pointer;
	list-style-type: none;
}
.header .search a {
	text-decoration: none;
}
.header .search li.selected a {
	color: #fff;
}
.header .menu {
	height: 4em;
}
.header .menu ul {
	margin: 0 0 1em 0;
	list-style-type: none;
}
.header .menu ul li {
	float: left;
	margin-right: 10px;
	list-style-type: none;
}
.header .menu .active {
	font-weight: bold;
}

/* sidebar */
.navigation ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;
}
.navigation ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;
}
.navigation .active {
	font-weight: bold;
}

/* footer */
.footer {
	font-size: 0.8em;
	margin-top: 10em;
	text-align: left;
	border-top: 1px solid #ddd;
}

.footer ul {
	list-style: none;
	margin-left: 0em;
}
.footer ul ul {
	margin-left: 1.5em;
}
'! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 8/26/2008 17:20'!
usefulCommandsWidget
	^ (PRComponent named: 'usefulcommands')
			componentClass: PRCommandsWidget;
			yourself! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 5/28/2008 15:16'!
userManagementPages
	
	^(PRPage named: 'usermanagement')
		title: '_User Mamangement';
		addChild: ((PRComponent named: 'users') componentClass: PUUsersWidget; yourself);
		addChild: ((PRComponent named: 'groups') componentClass: PUGroupsWidget; yourself);
		contents: '!!Users
+users+

!!Groups
+groups+';
		yourself! !

!PRDistribution methodsFor: 'pages' stamp: 'tg 8/27/2008 01:58'!
viewsPage
	^ views := (PRPage named: 'views')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRViewsWidget;
				yourself);
		contents: '!!!!!!!!Views
			+widget+'! !
